#ifndef DAL_H
#define DAL_H

#include "lrt.h"
#include "light.h"
#include "scene.h"

//class DirectionalAreaLight:public Light
class DirectionalAreaLight
{
  public:
  
  DirectionalAreaLight(Scene &scene, Spectrum power = Spectrum(1.),
    Float height = 1.0, Float theta = 0.0, Float phi = 0.0); 
  
  // do i need the following ??
  // DirectionalLight(SurfaceFunction * ud, 
  //   LightAttributes * attr); 

  Spectrum dE(const Point&, Point *Plight) const;

  Point Sample(Float u[2]);
  
  inline Vector GetDirection() { return lightDir; }

  private:

  BBox sceneBoundary;
  Vector lightDir;
  Float theta, phi;
  Float height;
  Spectrum power;
  Float dimU, dimV;
  Float lightZ;
  Float lightOffsetX;
  Float lightOffsetY;
  
};

#endif // DAL_H 
